'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

exports.default = virtualize;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _warning = require('warning');

var _warning2 = _interopRequireDefault(_warning);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// Approximate time needed to wait for the end of the transition.
//  weak

var ANIMATION_DELAY = 500;

// Render one more slide for going backward as it's more difficult to
// keep the window up to date.
var LEFT_OFFSET = 1;

function virtualize(MyComponent) {
  var Virtualize = function (_Component) {
    (0, _inherits3.default)(Virtualize, _Component);

    function Virtualize() {
      var _ref;

      var _temp, _this, _ret;

      (0, _classCallCheck3.default)(this, Virtualize);

      for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
        args[_key] = arguments[_key];
      }

      return _ret = (_temp = (_this = (0, _possibleConstructorReturn3.default)(this, (_ref = Virtualize.__proto__ || (0, _getPrototypeOf2.default)(Virtualize)).call.apply(_ref, [this].concat(args))), _this), _this.state = {}, _this.timer = null, _this.handleChangeIndex = function (indexContainer, indexLatest) {
        var indexDiff = indexContainer - indexLatest;

        process.env.NODE_ENV !== "production" ? (0, _warning2.default)(Math.abs(indexDiff) === 1, 'react-swipeable-view: The indexDiff should be abs equal to 1') : void 0;

        var index = _this.state.index + indexDiff;

        if (_this.props.onChangeIndex) {
          _this.props.onChangeIndex(index);
        } else {
          _this.setIndex(index, indexContainer, indexDiff);
        }
      }, _this.handleSwitching = function (index, type) {
        if (_this.timer) {
          clearTimeout(_this.timer);
          _this.timer = null;
        } else if (type === 'end') {
          _this.setWindowTimer();
        }

        if (_this.props.onSwitching) {
          _this.props.onSwitching(index, type);
        }
      }, _temp), (0, _possibleConstructorReturn3.default)(_this, _ret);
    }

    (0, _createClass3.default)(Virtualize, [{
      key: 'componentWillMount',
      value: function componentWillMount() {
        this.setState({
          index: this.props.index,
          indexContainer: this.props.overscanSlideCount
        });

        this.setWindow(this.props);
      }
    }, {
      key: 'componentWillReceiveProps',
      value: function componentWillReceiveProps(nextProps) {
        var index = nextProps.index;


        if (typeof index === 'number' && index !== this.props.index) {
          var indexDiff = index - this.props.index;
          this.setIndex(index, this.state.indexContainer + indexDiff, indexDiff);
        }
      }
    }, {
      key: 'componentWillUnmount',
      value: function componentWillUnmount() {
        clearInterval(this.timer);
      }
    }, {
      key: 'setIndex',
      value: function setIndex(index, indexContainer, indexDiff) {
        var _this2 = this;

        var nextState = {
          index: index,
          indexContainer: indexContainer,
          indexStop: this.state.indexStop
        };

        // We are going forward, let's render one more slide ahead.
        if (indexDiff > 0 && (!this.props.slideCount || nextState.indexStop < this.props.slideCount - 1)) {
          nextState.indexStop += 1;
        }

        // Extend the bounds if needed
        if (index > nextState.indexStop) {
          nextState.indexStop = index;
        }

        this.setState(nextState, function () {
          _this2.setWindowTimer();
        });
      }
    }, {
      key: 'setWindowTimer',
      value: function setWindowTimer() {
        var _this3 = this;

        clearTimeout(this.timer);
        this.timer = setTimeout(function () {
          _this3.setWindow();
        }, ANIMATION_DELAY);
      }
    }, {
      key: 'setWindow',
      value: function setWindow() {
        var state = arguments.length <= 0 || arguments[0] === undefined ? this.state : arguments[0];
        var slideCount = this.props.slideCount;


        var index = state.index;
        var leftAhead = this.props.overscanSlideCount + LEFT_OFFSET;
        var rightAhead = this.props.overscanSlideCount;

        if (slideCount) {
          if (leftAhead > index) {
            leftAhead = index;
          }

          if (rightAhead + index > slideCount - 1) {
            rightAhead = slideCount - index - 1;
          }
        }

        var nextState = {
          indexContainer: leftAhead,
          indexStart: index - leftAhead,
          indexStop: index + rightAhead
        };

        this.setState(nextState);
      }
    }, {
      key: 'render',
      value: function render() {
        var _props = this.props;
        var children = _props.children;
        var indexProp = _props.index;
        var onChangeIndex = _props.onChangeIndex;
        var overscanSlideCount = _props.overscanSlideCount;
        var slideCount = _props.slideCount;
        var slideRenderer = _props.slideRenderer;
        var other = (0, _objectWithoutProperties3.default)(_props, ['children', 'index', 'onChangeIndex', 'overscanSlideCount', 'slideCount', 'slideRenderer']);
        var _state = this.state;
        var indexContainer = _state.indexContainer;
        var indexStart = _state.indexStart;
        var indexStop = _state.indexStop;


        var slides = [];

        for (var slideIndex = indexStart; slideIndex <= indexStop; slideIndex++) {
          slides.push(slideRenderer({
            index: slideIndex,
            key: slideIndex
          }));
        }

        return _react2.default.createElement(
          MyComponent,
          (0, _extends3.default)({
            index: indexContainer,
            onChangeIndex: this.handleChangeIndex,
            onSwitching: this.handleSwitching
          }, other),
          slides
        );
      }
    }]);
    return Virtualize;
  }(_react.Component);

  Virtualize.defaultProps = {
    index: 0,
    overscanSlideCount: 2
  };
  process.env.NODE_ENV !== "production" ? Virtualize.propTypes = {
    /**
     * @ignore
     */
    children: function children(props, propName) {
      if (props[propName] !== undefined) {
        return new Error("The children property isn't supported.");
      }

      return null;
    },
    /**
     * @ignore
     */
    index: _react.PropTypes.number,
    /**
     * @ignore
     */
    onChangeIndex: _react.PropTypes.func,
    /**
     * @ignore
     */
    onSwitching: _react.PropTypes.func,
    /**
     * Number of slide to render before/after the visible slide.
     */
    overscanSlideCount: _react.PropTypes.number,
    /**
     * When set, it's adding a limit to the number of slide: [0, slideCount].
     */
    slideCount: _react.PropTypes.number,
    /**
     * Responsible for rendering a slide given an index.
     * ({ index: number }): node.
     */
    slideRenderer: _react.PropTypes.func.isRequired
  } : void 0;


  return Virtualize;
}